=== debian/control ===
Source: lsp-plugins
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mikhail Novosyolov <mikhailnov@dumalogiya.ru>
Build-Depends:
 debhelper (>= 9),
 ladspa-sdk,
 libexpat1-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libjack-jackd2-dev | libjack-dev,
 lv2-dev,
 php-cli,
 libcairo2-dev,
 libsndfile-dev
Standards-Version: 3.9.8
Homepage: http://lsp-plug.in/

Package: lsp-plugins
Architecture: all
Depends:
 lsp-plugins-jack,
 lsp-plugins-ladspa,
 lsp-plugins-lv2,
 lsp-plugins-vst
Description: LSP (Linux Studio Plugins) audio-plugins package
 This is a meta-package that pulls all packages with
 LSP (Linux Studio Plugins) plugins.
 .
 Audio effects: limiters, dynamic processors, expanders, gates,
 graphic equalisers, impulse responses, impulse reverbs, compressors,
 multiband compressors, parametric equalisers, phase detector,
 sidechain multiband compressors, sidechain limiters,
 sidechain dynamic processors, sidechain expanders, sidechain gates,
 sidechain compressors, slapback delays, delay compensators, triggers.
 .
 Synths: samplers, and multisamplers.
 .
 Tools: latency meters, oscillators, profiler, spectrum analyzers,
 and MIDI triggers
 .
 Available as LV2, LADSPA and jack-standalone.

Package: lsp-plugins-jack
Architecture: i386 amd64 armhf arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: LSP (Linux Studio Plugins) JACK plugins
 LSP (Linux Studio Plugins) JACK plugins

Package: lsp-plugins-ladspa
Architecture: i386 amd64 armhf arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: LSP (Linux Studio Plugins) LADSPA plugins
 LSP (Linux Studio Plugins) LADSPA plugins

Package: lsp-plugins-lv2
Architecture: i386 amd64 armhf arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: LSP (Linux Studio Plugins) LV2 plugins
 LSP (Linux Studio Plugins) LV2 plugins

Package: lsp-plugins-vst
Architecture: i386 amd64 armhf arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: LSP (Linux Studio Plugins) VST plugins
 LSP (Linux Studio Plugins) VST plugins

Package: lsp-plugins-doc
Architecture: all
Description: LSP (Linux Studio Plugins) plugins docs
 LSP (Linux Studio Plugins) VST plugins documentation
