=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH_CPU),$(filter $(DEB_HOST_ARCH_CPU),amd64))
	export BUILD_PROFILE=x86_64
else ifeq ($(DEB_HOST_ARCH_CPU),$(filter $(DEB_HOST_ARCH_CPU),i386))
	export BUILD_PROFILE=i586
else ifeq ($(DEB_HOST_ARCH_CPU),$(filter $(DEB_HOST_ARCH_CPU),armhf))
	export BUILD_PROFILE=armv7a
else ifeq ($(DEB_HOST_ARCH_CPU),$(filter $(DEB_HOST_ARCH_CPU),arm64))
	export BUILD_PROFILE=aarch64
endif

export PREFIX=/usr

%:
	dh $@

override_dh_auto_test:
	# FIXME tests are failing to build

override_dh_missing:
	dh_missing --fail-missing

override_dh_strip:
	dh_strip --no-automatic-dbgsym
